org.springframework.web.socket.sockjs.client

## Class JettyXhrTransport

- java.lang.Object
- - org.springframework.web.socket.sockjs.client.AbstractXhrTransport
  - - org.springframework.web.socket.sockjs.client.JettyXhrTransport

- All Implemented Interfaces:
    Lifecycle, InfoReceiver, Transport, XhrTransport

      public class JettyXhrTransport
      extends AbstractXhrTransport
      implements Lifecycle

  An XHR transport based on Jetty's `HttpClient`.

  When used for testing purposes (e.g. load testing) the `HttpClient` properties must be set to allow a larger than usual number of connections and threads. For example:

       HttpClient httpClient = new HttpClient();
       httpClient.setMaxConnectionsPerDestination(1000);
       httpClient.setExecutor(new QueuedThreadPool(500));

  Since:
    4.1
  Author:
    Rossen Stoyanchev

- - ### Field Summary

    - ### Fields inherited from class org.springframework.web.socket.sockjs.client.AbstractXhrTransport

      `logger, PRELUDE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JettyXhrTransport(org.eclipse.jetty.client.HttpClient httpClient)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `connectInternal(TransportRequest transportRequest, WebSocketHandler handler, URI url, HttpHeaders handshakeHeaders, XhrClientSockJsSession session, SettableListenableFuture<WebSocketSession> connectFuture)`
    `protected ResponseEntity<String>` | `executeInfoRequestInternal(URI infoUrl, HttpHeaders headers)`
    `protected ResponseEntity<String>` | `executeRequest(URI url, org.eclipse.jetty.http.HttpMethod method, HttpHeaders headers, String body)`
    `ResponseEntity<String>` | `executeSendRequestInternal(URI url, HttpHeaders headers, TextMessage message)`
    `org.eclipse.jetty.client.HttpClient` | `getHttpClient()`
    `boolean` | `isRunning()` Check whether this component is currently running.
    `void` | `start()` Start this component.
    `void` | `stop()` Stop this component, typically in a synchronous fashion, such that the component is fully stopped upon return of this method.

    - ### Methods inherited from class org.springframework.web.socket.sockjs.client.AbstractXhrTransport

      `connect, executeInfoRequest, executeSendRequest, getTransportTypes, isXhrStreamingDisabled, setXhrStreamingDisabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JettyXhrTransport

          public JettyXhrTransport(org.eclipse.jetty.client.HttpClient httpClient)

  - ### Method Detail

    - #### getHttpClient

          public org.eclipse.jetty.client.HttpClient getHttpClient()

    - #### start

          public void start()

      Description copied from interface: `Lifecycle`
      Start this component.

      Should not throw an exception if the component is already running.

      In the case of a container, this will propagate the start signal to all components that apply.

      Specified by:
        `start` in interface `Lifecycle`
      See Also:
        `SmartLifecycle.isAutoStartup()`

    - #### stop

          public void stop()

      Description copied from interface: `Lifecycle`
      Stop this component, typically in a synchronous fashion, such that the component is fully stopped upon return of this method. Consider implementing `SmartLifecycle` and its `stop(Runnable)` variant when asynchronous stop behavior is necessary.

      Note that this stop notification is not guaranteed to come before destruction: On regular shutdown, `Lifecycle` beans will first receive a stop notification before the general destruction callbacks are being propagated; however, on hot refresh during a context's lifetime or on aborted refresh attempts, a given bean's destroy method will be called without any consideration of stop signals upfront.

      Should not throw an exception if the component is not running (not started yet).

      In the case of a container, this will propagate the stop signal to all components that apply.

      Specified by:
        `stop` in interface `Lifecycle`
      See Also:
        `SmartLifecycle.stop(Runnable)`, `DisposableBean.destroy()`

    - #### isRunning

          public boolean isRunning()

      Description copied from interface: `Lifecycle`
      Check whether this component is currently running.

      In the case of a container, this will return `true` only if all components that apply are currently running.

      Specified by:
        `isRunning` in interface `Lifecycle`
      Returns:
        whether the component is currently running

    - #### connectInternal

          protected void connectInternal(TransportRequest transportRequest,
                                         WebSocketHandler handler,
                                         URI url,
                                         HttpHeaders handshakeHeaders,
                                         XhrClientSockJsSession session,
                                         SettableListenableFuture<WebSocketSession> connectFuture)

      Specified by:
        `connectInternal` in class `AbstractXhrTransport`

    - #### executeInfoRequestInternal

          protected ResponseEntity<String> executeInfoRequestInternal(URI infoUrl,
                                                                      HttpHeaders headers)

      Specified by:
        `executeInfoRequestInternal` in class `AbstractXhrTransport`

    - #### executeSendRequestInternal

          public ResponseEntity<String> executeSendRequestInternal(URI url,
                                                                   HttpHeaders headers,
                                                                   TextMessage message)

      Specified by:
        `executeSendRequestInternal` in class `AbstractXhrTransport`

    - #### executeRequest

          protected ResponseEntity<String> executeRequest(URI url,
                                                          org.eclipse.jetty.http.HttpMethod method,
                                                          HttpHeaders headers,
                                                          @Nullable
                                                          String body)